# libCEED: Tests

This page provides a brief description of the tests for the libCEED library.

The tests are organized by API object, and some tests are further organized, as required.

0. Ceed Tests  
1. CeedVector Tests  
    1.0. CeedVector general tests  
    1.1. CeedVector error tests  
2. CeedElemRestriction Tests  
3. CeedBasis Tests  
    3.0. CeedBasis utility tests  
    3.1. CeedBasis tensor basis tests  
    3.2. CeedBasis simplex basis tests  
    3.3. CeedBasis non-tensor H(div) basis tests  
    3.4. CeedBasis non-tensor H(curl) basis tests  
    3.5. CeedBasis evaluation at arbitrary points tests  
4. CeedQFunction Tests  
    4.0. CeedQFunction user code tests  
    4.1. CeedQFunction gallery code tests  
5. CeedOperator Tests  
    5.0. CeedOperator with tensor bases tests  
    5.1. CeedOperator with simplex bases tests  
    5.2. CeedOperator with operator composition tests  
    5.3. CeedOperator diagonal and CeedQFunction assembly tests  
    5.4. CeedOperator element inverse tests  
    5.5. CeedOperator multigrid level tests  
    5.6. CeedOperator full assembly tests  
    5.7. CeedOperator full assembly tests (extended)  
    5.8. CeedOperator H(div) and H(curl) tests
